    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025     * Other names may be trademarks of their respective owners.]
    026     *
    027     * -------------------------
    028     * SunPNGEncoderAdapter.java
    029     * -------------------------
    030     * (C) Copyright 2004-2008, by Richard Atkinson and Contributors.
    031     *
    032     * Original Author:  Richard Atkinson;
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 01-Aug-2004 : Initial version (RA);
    038     * 02-Feb-2007 : Removed author tags all over JFreeChart sources (DG);
    039     *
    040     */
    041
    042    package org.jfree.chart.encoders;
    043
    044    import java.awt.image.BufferedImage;
    045    import java.io.ByteArrayOutputStream;
    046    import java.io.IOException;
    047    import java.io.OutputStream;
    048
    049    import javax.imageio.ImageIO;
    050
    051    /**
    052     * Adapter class for the Sun PNG Encoder.  The ImageEncoderFactory will only
    053     * return a reference to this class by default if the library has been compiled
    054     * under a JDK 1.4+ and is being run using a JDK 1.4+.
    055     */
    056    public class SunPNGEncoderAdapter implements ImageEncoder {
    057
    058        /**
    059         * Get the quality of the image encoding (always 0.0).
    060         *
    061         * @return A float representing the quality.
    062         */
    063        public float getQuality() {
    064            return 0.0f;
    065        }
    066
    067        /**
    068         * Set the quality of the image encoding (not supported in this
    069         * ImageEncoder).
    070         *
    071         * @param quality  A float representing the quality.
    072         */
    073        public void setQuality(float quality) {
    074            //  No op
    075        }
    076
    077        /**
    078         * Get whether the encoder should encode alpha transparency (always false).
    079         *
    080         * @return Whether the encoder is encoding alpha transparency.
    081         */
    082        public boolean isEncodingAlpha() {
    083            return false;
    084        }
    085
    086        /**
    087         * Set whether the encoder should encode alpha transparency (not
    088         * supported in this ImageEncoder).
    089         *
    090         * @param encodingAlpha  Whether the encoder should encode alpha
    091         *                       transparency.
    092         */
    093        public void setEncodingAlpha(boolean encodingAlpha) {
    094            //  No op
    095        }
    096
    097        /**
    098         * Encodes an image in PNG format.
    099         *
    100         * @param bufferedImage  The image to be encoded.
    101         *
    102         * @return The byte[] that is the encoded image.
    103         *
    104         * @throws IOException
    105         */
    106        public byte[] encode(BufferedImage bufferedImage) throws IOException {
    107            ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
    108            encode(bufferedImage, outputStream);
    109            return outputStream.toByteArray();
    110        }
    111
    112        /**
    113         * Encodes an image in PNG format and writes it to an OutputStream.
    114         *
    115         * @param bufferedImage  The image to be encoded.
    116         * @param outputStream  The OutputStream to write the encoded image to.
    117         * @throws IOException
    118         */
    119        public void encode(BufferedImage bufferedImage, OutputStream outputStream)
    120            throws IOException {
    121            if (bufferedImage == null) {
    122                throw new IllegalArgumentException("Null 'image' argument.");
    123            }
    124            if (outputStream == null) {
    125                throw new IllegalArgumentException("Null 'outputStream' argument.");
    126            }
    127            ImageIO.write(bufferedImage, ImageFormat.PNG, outputStream);
    128        }
    129
    130    }